Page MenuHomePhabricator

HHVM "Recoverable fatal error" should log to "fatal" instead of "error" channel
Closed, ResolvedPublic

Description

Issues such as T132645 and T205675 were confusingly reported to the error channel in Logstash. This made me wonder "How could execution continue after this?" and if it really did continue, then "Why is there not also a fatal error in the logs?" (given every line after the line reported the error from would spew a "Cannot call on non-object null" error, but nothing like that is found.

Turns out, they are actually fatal (as they should be), and execution did stop. But due to HHVM's weird and magical error handling feature that reports warnings and fatals through the same callback, it is currently ending up in our "error" channel.

Details

Related Gerrit Patches:

Event Timeline

Krinkle created this task.Sep 27 2018, 11:53 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptSep 27 2018, 11:53 PM

Change 463393 had a related patch set uploaded (by Krinkle; owner: Krinkle):
[mediawiki/core@master] exception: Report uncaught "Catchable" fatal to "fatal" channel

https://gerrit.wikimedia.org/r/463393

Change 463393 merged by jenkins-bot:
[mediawiki/core@master] exception: Report uncaught "Catchable" fatal to "fatal" channel

https://gerrit.wikimedia.org/r/463393

Krinkle triaged this task as Medium priority.Sep 28 2018, 9:32 PM
Krinkle removed a project: Patch-For-Review.
Imarlier closed this task as Resolved.Oct 1 2018, 8:13 PM